Legrand / Raritan / Server Technology Xerus™ JSON-RPC API

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
webcam::StorageManager Interface Reference

The storage manager interface. More...

`import <StorageManager.idl;`

## Classes
struct | Activity
| Activity. More...
struct | ImageStorageMetaData
| StorageMetaData. More...
struct | ImageUploadStartedEvent
| Event: image upload to storage started. More...
struct | StorageImage
| StorageImage. More...
struct | StorageInformation
| Information. More...
struct | StorageMetaData
| StorageMetaData. More...
struct | StorageSettings
| Settings. More...
struct | WebcamStorageInfo
| Webcam Storage Info. More...

## Public Types
enum | StorageType { LOCAL , FTP , CIFS , NFS }
| StorageType. More...
enum | Direction { ASCENDING , DESCENDING }
| Direction. More...
enum | StorageStatus { INITIALIZING , READY }
| StorageStatus. More...

## Public Member Functions
vector< StorageType > | getSupportedStorageTypes ()
| Get supported storage types.
StorageInformation | getInformation ()
| get storage information
StorageSettings | getSettings ()
| get storage settings
int | setSettings (in StorageSettings settings)
| set storage settings
int | addImage (in Webcam webcam, in Image image, out long index)
| add an image to the storage
int | removeImages (in Webcam webcam, in long start, in int count, in Direction direction)
| remove an image of the storage
int | getMetaData (in Webcam webcam, in long start, in int count, in Direction direction, out vector< ImageStorageMetaData > meta)
| get meta data of images from storage
int | getImages (in Webcam webcam, in long start, in int count, in Direction direction, out vector< StorageImage > image)
| retrieve images from the storage
vector< Activity > | getActivities ()
| get all running activities
int | startActivity (in Webcam webcam, in int count, in int interval)
| start a capture activity
int | startActivityWithFolder (in Webcam webcam, in int count, in int interval, in string folder)
| Start a capture activity, storing the images to a specific storage folder.
int | stopActivity (in Webcam webcam)
| stop a capture activity

## Public Attributes
constant int | NO_ERROR = 0
| Error codes.
constant int | ERR_INVALID_PARAM = 1
| Invalid parameter for an operation.
constant int | ERR_INIT_IN_PROGRESS = 2
| Storage information is going to be initialized.
constant int | ERR_ALREADY_RUNNING = 3
| The activity is already running.
constant int | ERR_TOO_LARGE = 4
| The requested result is too large.
constant int | ERR_OPERATION_NOT_SUPPORTED = 5
| The requested operation is not supported on the current storage type.

## Detailed Description

The storage manager interface.

Definition at line 13 of file StorageManager.idl.

## Member Enumeration Documentation

## ◆ Direction

enum webcam::StorageManager::Direction

Direction.

Enumerator
ASCENDING | ascending
DESCENDING | descending

Definition at line 33 of file StorageManager.idl.

## ◆ StorageStatus

enum webcam::StorageManager::StorageStatus

StorageStatus.

Enumerator
INITIALIZING | Initializing is in progress,.
READY | Storage is ready for usage.

Definition at line 39 of file StorageManager.idl.

## ◆ StorageType

enum webcam::StorageManager::StorageType

StorageType.

Enumerator
LOCAL | Local.
FTP | FTP.
CIFS | CIFS.
NFS | NFS.

Definition at line 25 of file StorageManager.idl.

## Member Function Documentation

## ◆ addImage()

int webcam::StorageManager::addImage | ( | in Webcam | webcam,
|  | in Image | image,
|  | out long | index )

add an image to the storage

Parameters

  webcam | image source webcam
  image | image
  index | index of the added image

Returns
  NO_ERROR on success

## ◆ getActivities()

vector< Activity > webcam::StorageManager::getActivities | ( |  | ) |

get all running activities

Returns
  list of running activities

## ◆ getImages()

int webcam::StorageManager::getImages | ( | in Webcam | webcam,
|  | in long | start,
|  | in int | count,
|  | in Direction | direction,
|  | out vector< StorageImage > | image )

retrieve images from the storage

Note
  not supported for remote storage (CIFS and FTP)

Parameters

  webcam | image source webcam
  start | start index
  count | number of images
  direction | index counting direction
  image | result: list of storage images

Returns
  NO_ERROR on success
  ERR_TOO_LARGE too many images requested

## ◆ getInformation()

StorageInformation webcam::StorageManager::getInformation | ( |  | ) |

get storage information

Returns
  StorageInformation

## ◆ getMetaData()

int webcam::StorageManager::getMetaData | ( | in Webcam | webcam,
|  | in long | start,
|  | in int | count,
|  | in Direction | direction,
|  | out vector< ImageStorageMetaData > | meta )

get meta data of images from storage

Note
  not supported for remote storage (CIFS and FTP)

Parameters

  webcam | image source webcam
  start | start index
  count | number of images
  direction | index counting direction
  meta | result: list of storage meta data

Returns
  NO_ERROR on success
  ERR_TOO_LARGE too many information requested

## ◆ getSettings()

StorageSettings webcam::StorageManager::getSettings | ( |  | ) |

get storage settings

Returns
  StorageSettings

## ◆ getSupportedStorageTypes()

vector< StorageType > webcam::StorageManager::getSupportedStorageTypes | ( |  | ) |

Get supported storage types.

Returns
  a list of supported storage types

## ◆ removeImages()

int webcam::StorageManager::removeImages | ( | in Webcam | webcam,
|  | in long | start,
|  | in int | count,
|  | in Direction | direction )

remove an image of the storage

Note
  not supported for remote storage (CIFS and FTP)

Parameters

  webcam | image source webcam
  start | start index
  count | number of images
  direction | index counting direction

Returns
  NO_ERROR on success

## ◆ setSettings()

int webcam::StorageManager::setSettings | ( | in StorageSettings | settings | ) |

set storage settings

Parameters

  settings | settings structure

Returns
  NO_ERROR on success
  ERR_INVALID_PARAM invalid settings

## ◆ startActivity()

int webcam::StorageManager::startActivity | ( | in Webcam | webcam,
|  | in int | count,
|  | in int | interval )

start a capture activity

Parameters

  webcam | webcam
  count | number of images to store, zero is interpreted as infinite
  interval | interval in ms

Returns
  NO_ERROR on success
  ERR_INVALID_PARAM webcam not found

## ◆ startActivityWithFolder()

int webcam::StorageManager::startActivityWithFolder | ( | in Webcam | webcam,
|  | in int | count,
|  | in int | interval,
|  | in string | folder )

Start a capture activity, storing the images to a specific storage folder.

Parameters

  webcam | webcam
  count | number of images to store, zero is interpreted as infinite
  interval | interval in ms
  folder | folder path to store the images into

Returns
  NO_ERROR on success
  ERR_INVALID_PARAM webcam not found

## ◆ stopActivity()

int webcam::StorageManager::stopActivity | ( | in Webcam | webcam | ) |

stop a capture activity

Parameters

  webcam | webcam

Returns
  NO_ERROR on success
  ERR_INVALID_PARAM no matching activity found

## Member Data Documentation

## ◆ ERR_ALREADY_RUNNING

constant int webcam::StorageManager::ERR_ALREADY_RUNNING = 3

The activity is already running.

Definition at line 20 of file StorageManager.idl.

## ◆ ERR_INIT_IN_PROGRESS

constant int webcam::StorageManager::ERR_INIT_IN_PROGRESS = 2

Storage information is going to be initialized.

Definition at line 19 of file StorageManager.idl.

## ◆ ERR_INVALID_PARAM

constant int webcam::StorageManager::ERR_INVALID_PARAM = 1

Invalid parameter for an operation.

Definition at line 18 of file StorageManager.idl.

## ◆ ERR_OPERATION_NOT_SUPPORTED

constant int webcam::StorageManager::ERR_OPERATION_NOT_SUPPORTED = 5

The requested operation is not supported on the current storage type.

Definition at line 22 of file StorageManager.idl.

## ◆ ERR_TOO_LARGE

constant int webcam::StorageManager::ERR_TOO_LARGE = 4

The requested result is too large.

Definition at line 21 of file StorageManager.idl.

## ◆ NO_ERROR

constant int webcam::StorageManager::NO_ERROR = 0

Error codes.

Operation successful, no error

Definition at line 17 of file StorageManager.idl.

The documentation for this interface was generated from the following file:

- StorageManager.idl